#include <stdio.h>
#include "gl3w/gl3w.h"
#include <SFML/Window.hpp>

#ifdef __APPLE__
#include <fcntl.h>
#include <unistd.h>
#endif

float getVer()
{
	float ver = 0.0f;

	if (gl3wInit()) {
		fprintf(stderr, "failed to initialize OpenGL\n");
	}

	if (gl3wIsSupported(1, 1)) { ver = 1.1f; }
	if (gl3wIsSupported(1, 2)) { ver = 1.2f; }
	if (gl3wIsSupported(1, 3)) { ver = 1.3f; }
	if (gl3wIsSupported(1, 4)) { ver = 1.4f; }
	if (gl3wIsSupported(1, 5)) { ver = 1.5f; }

	if (gl3wIsSupported(2, 0)) { ver = 2.0f; }
	if (gl3wIsSupported(2, 1)) { ver = 2.1f; }

	if (gl3wIsSupported(3, 0)) { ver = 3.0f; }
	if (gl3wIsSupported(3, 1)) { ver = 3.1f; }
	if (gl3wIsSupported(3, 2)) { ver = 3.2f; }
	if (gl3wIsSupported(3, 3)) { ver = 3.3f; }

	if (gl3wIsSupported(4, 0)) { ver = 4.0f; }
	if (gl3wIsSupported(4, 1)) { ver = 4.1f; }
	if (gl3wIsSupported(4, 2)) { ver = 4.2f; }
	if (gl3wIsSupported(4, 3)) { ver = 4.3f; }
	if (gl3wIsSupported(4, 4)) { ver = 4.4f; }
	if (gl3wIsSupported(4, 5)) { ver = 4.5f; }

	return ver;
    
    return ver;
}

int main(int argc, char const** argv)
{
    sf::err().rdbuf(NULL); //hide errors
    
#ifdef __APPLE__
    //stop nslog messages
    // http://stackoverflow.com/questions/12608988/hiding-nslog-output-coming-from-precompiled-library
    int nullFD = open("/dev/null", O_WRONLY);
    int oldFD = dup(2); // Duplicate the old file descriptor, so it can be restored
    dup2(nullFD, 2); // Redirect
#endif

    sf::VideoMode mode(100, 100, 32);
#ifdef __linux__
    sf::ContextSettings settings(32, 0, 0, 4, 5); //try for core
#else
    sf::ContextSettings settings(0, 0, 0, 4, 5, sf::ContextSettings::Core); //try for core
#endif
    sf::Window window(mode, "glver", sf::Style::Default, settings);

    float ver = getVer();
    
#ifdef __APPLE__
    dup2(oldFD, 2); // Redirect back
    close(oldFD); // Not needed anymore
#endif
    
    
    if( ver < 1.0f ) {
        printf("OpenGL is not supported.\n");
        return 0;
    }
    
    printf("OpenGL version %.1f is supported.\n", ver);
    return 0;


    return EXIT_SUCCESS;
}
